/*
 TECNISA - TECNOLOGIA EM INFORMTICA

 NOME: IMPOSTO_PEDIDO

 DESCRIO:
  PROCEDIMENTO PARA ATUALIZAO DOS IMPOSTOS TOTAIS DO PEDIDO

 RAISERROR('', 16,1);

 @C:\Win_605\Sql\End_Conv\SqlServer\2874_PEDFUNS_IMPOSTO_PEDIDO.sql
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'IMPOSTO_PEDIDO'  and
            type = 'P'                  and
            u.uid = o.uid               and
            u.name = USER)
  DROP PROCEDURE IMPOSTO_PEDIDO
  GO

CREATE PROCEDURE IMPOSTO_PEDIDO @P_FILIAL     VARCHAR(4),
                                @P_NRPEDIDO   VARCHAR(10)

AS
   DECLARE @V_EXISTEIMP INTEGER;

   DECLARE @V_IMPOSITEMTOT_CDFILIAL     VARCHAR(04);
   DECLARE @V_IMPOSITEMTOT_NRPEDIDO     VARCHAR(10);
   DECLARE @V_IMPOSITEMTOT_CDIMPOSTO    VARCHAR(02);
   DECLARE @V_IMPOSITEMTOT_VRIMPOSTOTAL DOUBLE PRECISION;
   DECLARE @V_IMPOSITEMTOT_VRBASETOTAL  DOUBLE PRECISION;

BEGIN
   DELETE FROM IMPOSNFTOTPED
   WHERE CDFILIAL  = @P_FILIAL
     AND NRPEDIDO  = @P_NRPEDIDO;

   DECLARE C_IMPOSITEMTOT CURSOR FOR SELECT CDFILIAL, NRPEDIDO, CDIMPOSTO,
                                            SUM(VRIMPOSTOITPED) AS VRIMPOSTOTAL,
                                            SUM(VRBASECALCITPED) AS VRBASETOTAL
                                       FROM IMPITEMPEDIDO
                                      WHERE CDFILIAL  = @P_FILIAL
                                        AND NRPEDIDO  = @P_NRPEDIDO
                                     GROUP BY CDFILIAL, NRPEDIDO, CDIMPOSTO;

   OPEN C_IMPOSITEMTOT;

   FETCH NEXT FROM C_IMPOSITEMTOT INTO @V_IMPOSITEMTOT_CDFILIAL,  @V_IMPOSITEMTOT_NRPEDIDO, @V_IMPOSITEMTOT_CDIMPOSTO,
                                       @V_IMPOSITEMTOT_VRIMPOSTOTAL, @V_IMPOSITEMTOT_VRBASETOTAL;

   WHILE (@@FETCH_STATUS = 0)
   BEGIN
      SET @V_EXISTEIMP = 0;
      SELECT @V_EXISTEIMP = COUNT(1)
        FROM IMPOSNFTOTPED I, IMPOSTO T
       WHERE I.CDFILIAL  = @P_FILIAL
         AND I.NRPEDIDO  = @P_NRPEDIDO
         AND I.CDIMPOSTO = @V_IMPOSITEMTOT_CDIMPOSTO
         AND I.CDIMPOSTO = T.CDIMPOSTO;
      IF (@V_EXISTEIMP > 0) BEGIN
         INSERT INTO IMPOSNFTOTPED
         (CDFILIAL, NRPEDIDO, CDIMPOSTO, VRTOTIMPPED, VRTOTBCALCPED)
         VALUES
         (@V_IMPOSITEMTOT_CDFILIAL, @V_IMPOSITEMTOT_NRPEDIDO, @V_IMPOSITEMTOT_CDIMPOSTO, @V_IMPOSITEMTOT_VRIMPOSTOTAL, @V_IMPOSITEMTOT_VRBASETOTAL);
      END
      ELSE BEGIN
         UPDATE IMPOSNFTOTPED
            SET VRTOTIMPPED  = @V_IMPOSITEMTOT_VRIMPOSTOTAL,
                VRTOTBCALCPED = @V_IMPOSITEMTOT_VRBASETOTAL
          WHERE CDFILIAL  = @V_IMPOSITEMTOT_CDFILIAL
            AND NRPEDIDO  = @V_IMPOSITEMTOT_NRPEDIDO
            AND CDIMPOSTO = @V_IMPOSITEMTOT_CDIMPOSTO;

      END;
      FETCH NEXT FROM C_IMPOSITEMTOT INTO @V_IMPOSITEMTOT_CDFILIAL,  @V_IMPOSITEMTOT_NRPEDIDO, @V_IMPOSITEMTOT_CDIMPOSTO,
                                          @V_IMPOSITEMTOT_VRIMPOSTOTAL, @V_IMPOSITEMTOT_VRBASETOTAL;
   END;

   CLOSE C_IMPOSITEMTOT;
   DEALLOCATE C_IMPOSITEMTOT;

END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'IMPOSTO_PEDIDO','6.05.xxx';
GO


